--- old/usr/src/uts/common/os/devcfg.c	2013-03-05 03:43:49.506544350 +0000
+++ new/usr/src/uts/common/os/devcfg.c	2013-03-05 03:43:49.512655285 +0000
@@ -22,6 +22,7 @@
  * Copyright (c) 2000, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Nexenta Systems, Inc. All rights reserved.
  * Copyright 2012 Garrett D'Amore <garrett@damore.org>.  All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  */
 
 #include <sys/note.h>
@@ -5890,6 +5891,13 @@
 		}
 	}
 
+	/*
+	 * dv_mknod places a hold on the dev_info_t for each devfs node
+	 * created.  If we're to succeed in detaching this device, we must
+	 * first release all outstanding references held by devfs.
+	 */
+	(void) devfs_clean(pdip, NULL, DV_CLEAN_FORCE);
+
 	if (i_ddi_detachchild(dip, flags) != DDI_SUCCESS) {
 		if (flags & NDI_DEVI_OFFLINE) {
 			RIO_DEBUG((CE_NOTE, "devi_detach_node: offline failed."
